unit veditorsimple;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  StdCtrls, ComCtrls,uvacercade,bommemo;

type

  { TVentanaEditor }

  TVentanaEditor = class(TForm)
    Editor: TBOMMemo;
    Imagenes: TImageList;
    MenuArchivo: TMenuItem;
    MenuEdicion: TMenuItem;
    MenuAcercaDe: TMenuItem;
    MenuAbrir: TMenuItem;
    MenuGuardar: TMenuItem;
    MenuCopiar: TMenuItem;
    MenuBOM: TMenuItem;
    MenuNuevo: TMenuItem;
    MenuPegar: TMenuItem;
    MenuSalir: TMenuItem;
    MenuPrincipal: TMainMenu;
    BarraHerramientas: TToolBar;
    BNuevo: TToolButton;
    BAbrir: TToolButton;
    BGuardar: TToolButton;
    ToolButton1: TToolButton;
    BCopiar: TToolButton;
    BPegar: TToolButton;
    ToolButton2: TToolButton;
    BBOM: TToolButton;
    ToolButton3: TToolButton;
    BTitulos: TToolButton;
    VentanaGuardar: TSaveDialog;
    VentanaAbrir: TOpenDialog;
    procedure BTitulosClick(Sender: TObject);
    procedure FormClose(Sender: TObject);// var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MenuAbrirClick(Sender: TObject);
    procedure MenuAcercaDeClick(Sender: TObject);
    procedure MenuBOMClick(Sender: TObject);
    procedure MenuCopiarClick(Sender: TObject);
    procedure MenuGuardarClick(Sender: TObject);
    procedure MenuNuevoClick(Sender: TObject);
    procedure MenuPegarClick(Sender: TObject);
    procedure MenuSalirClick(Sender: TObject);
    procedure CambiarEstadoBOM(estado:boolean);
    procedure EditorChange(Sender:TObject);
  private
    { private declarations }
  public
    { public declarations }
    modificado:boolean;
  end; 

var
  VentanaEditor: TVentanaEditor;

implementation

{$R *.lfm}

{ TVentanaEditor }

procedure TVentanaEditor.MenuSalirClick(Sender: TObject);
begin
  Close
end;

procedure TVentanaEditor.CambiarEstadoBOM(estado: boolean);
begin
  if estado then
    Begin
      BBOM.ImageIndex:=6;
      BBOM.Down:=true;
      MenuBOM.Checked:=true;
    end
  else
    Begin
      BBOM.ImageIndex:=5;
      BBOM.Down:=false;
      MenuBOM.Checked:=false;
    end;
end;

procedure TVentanaEditor.EditorChange(Sender: TObject);
begin
  modificado:=true
end;

procedure TVentanaEditor.MenuCopiarClick(Sender: TObject);
begin
  Editor.CopyToClipboard;
end;

procedure TVentanaEditor.MenuGuardarClick(Sender: TObject);
begin
  if VentanaGuardar.Execute then
    Editor.Lines.SaveToFile(VentanaGuardar.FileName);
  modificado:=false;
end;

procedure TVentanaEditor.MenuNuevoClick(Sender: TObject);
begin
  FormClose(Sender);
  if Editor.Lines.Text<>'' then
    Editor.Lines.Text:='';
  CambiarEstadoBOM(false);
  modificado:=false
end;

procedure TVentanaEditor.MenuAbrirClick(Sender: TObject);
begin
  FormClose(Sender);
  if VentanaAbrir.Execute then
    Begin
     Editor.Lines.LoadFromFile(VentanaAbrir.FileName);
     CambiarEstadoBOM(Editor.BOM)
    end;
  modificado:=false
end;

procedure TVentanaEditor.BTitulosClick(Sender: TObject);
begin
  if BarraHerramientas.ShowCaptions then
    Begin
      BarraHerramientas.ShowCaptions:=false;
      BarraHerramientas.ShowHint:=true;
      BarraHerramientas.ButtonHeight:=40;
      BarraHerramientas.ButtonWidth:=40;
      BarraHerramientas.Height:=43;
      BTitulos.ImageIndex:=8;
    end
  else
    Begin
      BarraHerramientas.ShowCaptions:=true;
      BarraHerramientas.ShowHint:=false;
      BarraHerramientas.ButtonHeight:=60;
      BarraHerramientas.ButtonWidth:=60;
      BarraHerramientas.Height:=63;
      BTitulos.ImageIndex:=7;
    end;
end;

procedure TVentanaEditor.FormClose(Sender: TObject);
  //var CloseAction: TCloseAction);
begin
  if modificado then
    if mrYes=MessageDlg('Editor Simple','El documento actual no se ha guardado'+#13+'¿Desea guardarlo?',mtConfirmation,[mbYes,mbNo],0)
       then MenuGuardarClick(Sender)
end;

procedure TVentanaEditor.FormShow(Sender: TObject);
begin
  Editor:=TBOMMemo.create(self);
  Editor.Parent:=self;
  Editor.Align:=alClient;
  Editor.ScrollBars:=ssAutoBoth;
  modificado:=false;
  Editor.OnChange:=@EditorChange;

end;

procedure TVentanaEditor.MenuAcercaDeClick(Sender: TObject);
begin
  VAcercade.ShowModal;
end;

procedure TVentanaEditor.MenuBOMClick(Sender: TObject);
var aux:boolean;
begin
  if Editor.BOM then
    Begin
      Editor.QuitarBOM;
      if Editor.Lines.text='' then modificado:=false;
    end
  else
    Begin
      aux:=true;
      if Editor.Lines.text='' then aux:=false;
      Editor.PonerBOM;
      modificado:=aux
    end;
  CambiarEstadoBOM(Editor.BOM)
end;

procedure TVentanaEditor.MenuPegarClick(Sender: TObject);
begin
  Editor.PasteFromClipboard;
end;

end.

